of		equ	offset
sh		equ	short

code		segment
		assume	cs:code

		org	2ch
env		dw	?			; our environment segment

		org	5ch		; can't overwrite memory any further up
old8		label	dword
old_int8	dw	?,?		; store old int 8 vector here
slock		db	?		; store scroll lock status
in_here		db	?		; = 1 => in hold state loop
new8		label	word		; shall move int 8 splice routine here

		org	100h
begin:		jmp	sh start

new_int8	proc	far		; replacement int 8 routine
		pushf			; simulate int 8
		cli
		call	old8
		push	bx		; save
		push	ds
		mov	bx,40h		; address DOS data area
		mov	ds,bx
		mov	bx,17h		;   and the keyboard status byte
		mov	bl,[bx]		; get status byte
		and	bl,10h		; isolate the scroll lock bit
		mov	slock,bl	; store for hold test
		pop	ds		; restore
		pop	bx
		jz	ni_out		; leave if scroll lock off
		cmp	in_here,1	; are we in hold loop already?
		je	ni_out		; yes, leave; no reentrance
		mov	in_here,1	; in hold state now
		push	ax		; save
		push	bx
		push	cx
		push	dx
		mov	ah,3		; read cursor position
		int	10h
		mov	ah,1		; set cursor size
		or	ch,20h		; make cursor vanish
		int	10h
		sti			; need interrupts to get us out
hold:		cmp	slock,10h	; scroll lock still on?
		jne	hold_out	; no, abolish the hold state
		jmp	sh hold		; yes, continue testing

hold_out:	mov	in_here,0	; no longer in hold state
		mov	ah,3		; read cursor position
		int	10h
		mov	ah,1		; set cursor size
		and	ch,0dfh		; nix the vanish bit
		int	10h
		pop	dx		; restore
		pop	cx
		pop	bx
		pop	ax
ni_out:		iret
new_int8	endp

size8		equ	$ - of new_int8

		assume	ds:code		; ds addressing ok now

start:		mov	ax,3508h	; get current int 8 vector
		int	21h
		mov	old_int8,bx	; save old vector
		mov	old_int8+2,es

		mov	in_here,0	; initialize reentrance flag
		push	cs		; cs back to es
		pop	es
		mov	si,of new_int8	; point to replacement int 8 code
		mov	di,of new8	; set destination
		mov	cx,size8	; and size of code
		cld			; insure forward
		rep	movsb		; copy code to new location

		mov	ax,2508h	; replace old int 8 with
		mov	dx,of new8	;   the new int 8 routine
		int	21h

		mov	ah,49h		; release the program's environment copy
		mov	es,env		; es has segment to be released
		int	21h

		mov	dx,of new8+size8; save needed PSP and code of new int 8
		add	dx,15		; round up to next paragraph
		mov	cl,4		; divide by 16
		shr	dx,cl		;   to obtain paragraphs to save
		mov	ax,3100h	; TSR with error code = 0
		int	21h

code		ends
		end	begin
